/*
 * pWinding.java
 *
 * (C) 2005, Alex S.
 */

/**
 * winding class, represents points on a face
 */
public class pWinding {
    public int size = 0;
    public double[] x = new double[32];
    public double[] y = new double[32];
    public double[] z = new double[32];

    public void average(double[] p){
        if (size <= 0)
            return;
        double x,y,z;
        x = y = z = 0.0;
        for (int i=0;i<size;i++) {
            x += this.x[i];
            y += this.y[i];
            z += this.z[i];
        }
        p[0] = x / size;
        p[1] = y / size;
        p[2] = z / size;
    }

    public pPlane makePlane(){
        return pPlane.fromPoints(
            new double[]{x[0],y[0],z[0],1},
            new double[]{x[1],y[1],z[1],1},
            new double[]{x[2],y[2],z[2],1}
        );
    }

    public String toString(){
        StringBuffer sb = new StringBuffer();
        sb.append("pWinding[");
        for(int i=0;i<size;i++){
            sb.append("("+x[i]+","+y[i]+","+z[i]+")");
            if(i < size - 1)
                sb.append(",");
        }
        sb.append("];");
        return sb.toString();
    }

}

