/*
 * pBSPNode.java
 *
 * (C) 2005, Alex S.
 */
 
import java.util.*;

/**
 * the bsp tree node
 */
public class pBSPNode {
    public int type = 0;
    public static final int TREENODE = 0;
    public static final int LEAFNODE = 1;

    public pPlane plane = new pPlane();
    public pBSPNode front = null;
    public pBSPNode back = null;

    // faces that are on this node.
    public Vector faces = new Vector();

    public Vector brushes = new Vector();

    public pBSPNode(){
        type = TREENODE;
    }
    public pBSPNode(int type){
        this.type = type;
    }
}


